-- Turbine Imports..
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

-- Plugin Imports..
import "GaluhadPlugins.Hytbold.VindarPatch";
import "GaluhadPlugins.Hytbold.Strings";
import "GaluhadPlugins.Hytbold.Armour";
import "GaluhadPlugins.Hytbold.QuestStrings";
import "GaluhadPlugins.Hytbold.PluginFunctions";
import "GaluhadPlugins.Hytbold.GeneralFunctions";
import "GaluhadPlugins.Hytbold.Globals";
import "GaluhadPlugins.Hytbold.Images";
import "GaluhadPlugins.Hytbold.Onscreen";
import "GaluhadPlugins.Hytbold.MessageBox";
import "GaluhadPlugins.Hytbold.DropDown";
import "GaluhadPlugins.Hytbold.Tooltip";
import "GaluhadPlugins.Hytbold.ChatLogger";
import "GaluhadPlugins.Hytbold.Alert";

-- Windows --
import "GaluhadPlugins.Hytbold.MainWin";
import "GaluhadPlugins.Hytbold.ArmourWin";
--import "GaluhadPlugins.Hytbold.ItemIDWin";

-- Other imports --
import "GaluhadPlugins.Hytbold.Commands";


-----------------------------------------------------------------------------------------------------------

function saveData()

	-- Store the settings table.
	PatchDataSave(Turbine.DataScope.Character, "Hytbold_Settings", SETTINGS);
	PatchDataSave(Turbine.DataScope.Server, "Hytbold_CharData", _CHARDATA);

end


function loadData()

	---------------------------------------------------------------------------------------------------------------------------------
	-- SAVED SETTINGS --
	local SavedSettings = {};
	SavedSettings = PatchDataLoad(Turbine.DataScope.Character, "Hytbold_Settings");

	-- Check the saved settings to make sure it is still compatible with newer updates, add in any missing default settings
	if type(SavedSettings) == 'table' then
		local tempSETTINGS = {};
		tempSETTINGS = deepcopy(DEFAULT_SETTINGS);
		SETTINGS = mergeTables(tempSETTINGS,SavedSettings);
	else
		SETTINGS = deepcopy(DEFAULT_SETTINGS);
	end

	----------------------------------------------------------------------------------------------------------------------------------
	-- SAVED CHARACTER DATA --
	local SavedCharData = {};
	SavedCharData = PatchDataLoad(Turbine.DataScope.Server, "Hytbold_CharData");

	-- Check the saved settings to make sure it is still compatible with newer updates, add in any missing default settings
	if type(SavedCharData) == 'table' then
		_CHARDATA = deepcopy(SavedCharData);
	end

	----------------------------------------------------------------------------------------------------------------------------------

end


function DrawWindows()

	DrawMainWin();
	DrawArmourWin();

end


Turbine.Plugin.Unload = function (sender, args)
	-- Save the data when the plugin unloads.
	saveData();
end


-- Initiate load sequence
loadData();
CheckCharData();
DrawWindows();
InitiateChatLogger();
RegisterCommands();

-- Load text
Debug("Loaded '" .. PLUGINNAME .. "' v" .. Plugins["Hytbold Assistant"]:GetVersion() .. " by Galuhad");
Debug(" " .. _LANG.CREDITS[SETTINGS.LANGUAGE]);
if wMainWinParent:IsVisible() == false then
	Debug(_LANG.COMMAND[SETTINGS.LANGUAGE]);
end
